
--we need a credential object
IF NOT EXISTS
(SELECT * FROM sys.credentials 
WHERE name = 'azurecredential')
CREATE CREDENTIAL azurecredential WITH IDENTITY = '[storage]'
,SECRET = '' ;


--create a full backup
BACKUP DATABASE AdventureWorks2012 
TO URL = 'https://[storage].blob.core.windows.net/[container]/AdventureWorks2012.bak' 
      WITH CREDENTIAL = 'azurecredential' 
     ,COMPRESSION
	 ,FORMAT
     ,STATS = 5;
GO 


--backup the database and the log
USE master;
GO
ALTER DATABASE AdventureWorks2012
   SET RECOVERY FULL;
GO

-- Back up the full AdventureWorks2012 database.
       -- First create a file name for the backup file with DateTime stamp

DECLARE @Full_Filename AS VARCHAR (300);
SET @Full_Filename = 'https://[storage].blob.core.windows.net/[container]/AdventureWorks2012_Full_'+ 
REPLACE (REPLACE (REPLACE (CONVERT (VARCHAR (40), GETDATE (), 120), '-','_'),':', '_'),' ', '_') + '.bak'; 
--Back up Adventureworks2012 database
PRINT @Full_FileName

BACKUP DATABASE AdventureWorks2012
TO URL =  @Full_Filename
WITH CREDENTIAL = 'azurecredential'
,COMPRESSION
GO

-- Back up the AdventureWorks2012 log.
DECLARE @Log_Filename AS VARCHAR (300);
SET @Log_Filename = 'https://[storage].blob.core.windows.net/[container]/AdventureWorks2012_Log_'+ 
REPLACE (REPLACE (REPLACE (CONVERT (VARCHAR (40), GETDATE (), 120), '-','_'),':', '_'),' ', '_') + '.trn';
BACKUP LOG AdventureWorks2012
 TO URL = @Log_Filename
WITH CREDENTIAL = 'azurecredential'
,COMPRESSION
,STATS = 5;
GO

--Back up the files in Primary:
BACKUP DATABASE AdventureWorks2012
   FILEGROUP = 'Primary'
   TO URL = 'https://[storage].blob.core.windows.net/[container]/AdventureWorks2012files.bck'
   WITH CREDENTIAL = 'azurecredential'
   ,COMPRESSION;
GO

--create a differential backup on the primary filegroup
--Back up the files in Primary:
BACKUP DATABASE AdventureWorks2012
   FILEGROUP = 'Primary'
   TO URL = 'https://[storage].blob.core.windows.net/[container]/AdventureWorks2012filesdiff.bck'
   WITH 
      CREDENTIAL = 'azurecredential'
      ,COMPRESSION
  ,DIFFERENTIAL;
GO


