﻿##############################
#import sql powershell module
##############################
Import-Module sqlps

###############################
# create variables
$backupUrlContainer = "https://[storage].blob.core.windows.net/[container]/"
$credentialName = "azurecredential"
$srvPath = "SQLSERVER:\SQL\SQLONPREMISES\SQL2014PG" 
###############################

# navigate to SQL Server Instance
CD $srvPath 
dir Databases

# generate backup file name
$backupFile = $backupUrlContainer + "mydb1poweshell_" + (Get-Date).ToString("s").Replace("-","_").Replace(":", "_").Replace(" ","_").Replace("/", "_") +  ".bak"
$backupFile

# backup Database to URL
Backup-SqlDatabase -Database mydb1 -backupFile $backupFile  -SqlCredential $credentialName -CompressionOption On   

#Create a unique file name for log backup
$backupFile = $backupUrlContainer + "mydb1_" + (Get-Date).ToString("s").Replace("-","_").Replace(":", "_").Replace(" ","_").Replace("/", "_") +  ".trn"
$backupFile
#Backup Log to URL
Backup-SqlDatabase -Database mydb1 -backupFile $backupFile  -SqlCredential $credentialName -CompressionOption On -BackupAction Log  

#create a unique filegroup file name backup
$backupFile = $backupUrlContainer + "mydb1_" + (Get-Date).ToString("s").Replace("-","_").Replace(":", "_").Replace(" ","_").Replace("/", "_") +  ".bck"
$backupFile
#Backup Primary File Group to URL
Backup-SqlDatabase -Database AdventureWorks2012 -backupFile $backupFile  -SqlCredential $credentialName -CompressionOption On -BackupAction Files -DatabaseFileGroup Primary  


#########################
## RESTORE
#########################

#create a unique file name for the full backup
$backupdbFile = $backupUrlContainer + "mydb1_" + (Get-Date).ToString("s").Replace("-","_").Replace(":", "_").Replace(" ","_").Replace("/", "_") +  ".bak"

# Full database backup to URL
Backup-SqlDatabase -Database mydb1 -backupFile $backupdbFile  -SqlCredential $credentialName -CompressionOption On    

#Create a unique file name for the tail log backup
$backuplogFile = $backupUrlContainer + "mydb1_" + (Get-Date).ToString("s").Replace("-","_").Replace(":", "_").Replace(" ","_").Replace("/", "_") +  ".trn"

#Backup tail log to URL
Backup-SqlDatabase -Database mydb1 -backupFile $backupFile  -SqlCredential $credentialName  -BackupAction Log -NoRecovery  

# Restore Database and move files
$newDataFilePath = New-Object Microsoft.SqlServer.Management.Smo.RelocateFile ("mydb1_Data","C:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\mydb1_rest.mdf")
$newLogFilePath = New-Object Microsoft.SqlServer.Management.Smo.RelocateFile("mydb1_Log","C:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\mydb1_rest.ldf")

Restore-SqlDatabase -Database mydb1_rest -SqlCredential $credentialName -BackupFile $backupdbFile -RelocateFile @($newDataFilePath,$newLogFilePath)

