IF NOT EXISTS (select * from sys.credentials WHERE name='https://[storage].blob.core.windows.net/[container]')
BEGIN
CREATE CREDENTIAL [https://[storage].blob.core.windows.net/[container]]
   WITH IDENTITY='SHARED ACCESS SIGNATURE', 
   SECRET = ''
END

GO

CREATE DATABASE SQLDbOnAzureStorage
CONTAINMENT = PARTIAL
ON 
   (NAME = file_data1, FILENAME = 'https://[storage].blob.core.windows.net/[container]/filedata1.mdf', SIZE = 5MB),
   (NAME = file_data2, FILENAME = 'https://[storage].blob.core.windows.net/[container]/filedata2.mdf', SIZE = 5MB)
 LOG ON 
(NAME = file_log1, FILENAME = 'https://[storage].blob.core.windows.net/[container]/filelog1.ldf', SIZE = 1MB) 

GO

USE SQLDbOnAzureStorage
GO

CREATE TABLE tUsers
(
	ID INT PRIMARY KEY IDENTITY (1,1),
	FirstName nVarchar(50),
	LastName nVarchar(50)
)

INSERT INTO tUsers
(
	FirstName, LastName
)
VALUES
(
	'Francesco', 'Diaz'
)


USE master
GO

EXEC sp_detach_db N'SQLDbOnAzureStorage';

--


